/*
 * $Id: fancyqt4log.h 900 2011-03-15 18:16:18Z fancylibs $
 *
 *  Created on: 12.05.2010
 *      Author: lech
 */

#include "fancyqt4.h"

#include <fancylog.h>

#ifndef FANCYQT4LOG_H_
#define FANCYQT4LOG_H_

// facility masks:
// facility "fancyqt4base"
#define  FANCYQT4_LOG_BASE     (1<<0)
// facility "fancyqt4remoting"
#define  FANCYQT4_LOG_REMOTING (1<<1)

namespace Fancy {

namespace Qt4 {

extern FANCYQT4_API fancylog_service *log_service;

// parse for logging cmdline args and filter out recognized options.
void FANCYQT4_API fancylog_parse_arg (int *argc, char **argv);

inline void vfancylog (int facility,
                       int priority, const char *fmt, va_list ap)
{
    va_list aq;
    va_copy(aq,ap);
    ::vfancylog(log_service,facility,priority,fmt,aq);
    va_end(aq);
}

#ifdef __GNUG__
inline void fancylog (int facility,
                      int priority, const char *fmt, ...)
__attribute__((format(printf,3,4)));

#endif

inline void fancylog (int facility,
                      int priority, const char *fmt, ...)
{
    va_list ap;
    va_start(ap, fmt);
    vfancylog(facility,priority,fmt,ap);
    va_end(ap);
}

}} // end namespaces

#endif /* FANCYQT4LOG_H_ */
