/*
 * $Id: fancyqt4onewayinvocationcall.h 653 2010-05-12 14:01:30Z fancylibs $
 *
 *  Created on: 11.05.2010
 *      Author: lech
 */

#ifndef FANCYQT4ONEWAYINVOCATIONCALL_H_
#define FANCYQT4ONEWAYINVOCATIONCALL_H_

#include <fancyqt4.h>
#include <fancyobject.h>

namespace Fancy {
class Map;
//class String;
namespace Sock {
class InvocationContext;
}

namespace Qt4 {

/**
 * A POJO to propagate a OneWayHandler's doOneWay() call asynchronously invocation to a GUI component.
 */
class OneWayInvocationCall : public Fancy::Object
{
    Fancy::ObjPtr<Sock::InvocationContext> ctx;
    Fancy::Object::ptr_t arg;
    Fancy::ObjPtr<Map> metadata;

public:

    typedef Fancy::ObjPtr<OneWayInvocationCall> ptr_t;

    /**
     * Construct a OneWayInvocationCall
     * @param ctx counterpart for ctx in Fancy::Sock::OneWayHandler.doOneWay()
     * @param arg counterpart for arg in Fancy::Sock::OneWayHandler.doOneWay()
     * @param metadata counterpart for metadata in Fancy::Sock::OneWayHandler.doOneWay()
     * @return
     */
    static ptr_t newInstance(const Fancy::ObjPtr<Sock::InvocationContext> &ctx,
                             const Fancy::Object::ptr_t &arg,
                             const Fancy::ObjPtr<Map> &metadata);

    /** returns ctx from Fancy::Sock::OneWayHandler.doOneWay() */
    Fancy::ObjPtr<Sock::InvocationContext> getContext() const;

    /** returns arg from Fancy::Sock::OneWayHandler.doOneWay() */
    Fancy::Object::ptr_t getArg() const;

    /** returns metadata from Fancy::Sock::OneWayHandler.doOneWay() */
    Fancy::ObjPtr<Map> getMetadata() const;

protected:

    OneWayInvocationCall(const Fancy::ObjPtr<Sock::InvocationContext> &_ctx,
                         const Fancy::Object::ptr_t &_arg,
                         const Fancy::ObjPtr<Map> &_metadata);

    virtual ~OneWayInvocationCall();

};

}}

#endif /* FANCYQT4ONEWAYINVOCATIONCALL_H_ */
