/*
 * $Id: fancyqt4onewayinvocationcallemitter.h 653 2010-05-12 14:01:30Z fancylibs $
 *
 *  Created on: 11.05.2010
 *      Author: lech
 */

#ifndef FANCYQT4ONEWAYINVOCATIONCALLEMITTER_H_
#define FANCYQT4ONEWAYINVOCATIONCALLEMITTER_H_

#include "fancyqt4.h"
#include "fancyqt4onewayinvocationcall.h"

#include <fancyobject.h>

#include <QtCore/qobject.h>


namespace Fancy {

namespace Qt4 {

/**
 * A sender object to propagate a OneWayHandler's doOneWay() call asynchronously invocation to a GUI component.
 */
class FANCYQT4_API OneWayInvocationCallEmitter : public QObject {

    Q_OBJECT

public:

    /**
     * Construct a OneWayInvocationCallEmitter
     * @param parent An optional parent object.
     * return A new instance.
     */
    OneWayInvocationCallEmitter(QObject * parent = 0);

    virtual ~OneWayInvocationCallEmitter();

    /**
     * This signal is emitted when a oneway invocation call occurs.
     *
     * @param call The POJO with the data from Fancy::Sock::OneWayHandler.doOneWay(...)
     */
    Q_SIGNAL void oneWayInvocationCallReceived(const Fancy::Qt4::OneWayInvocationCall::ptr_t &call);

};

}} // end namespaces

#endif /* FANCYQT4ONEWAYINVOCATIONCALLEMITTER_H_ */
